
# --- PWM configure
BASECLOCK = 48000000
DIVIDE1 = 23

# --- octave
def build_octave(tone_c)
    oct = []
    oct[0] = tone_c
    for i in 1...12 do
      oct[i] = tone_c * (2.0 ** (i/12.0))
    end
    oct
end


# --- base tone A2=440Hz
# midi key = 36
key_c3 = 440.0 / (2.0 ** (9.0/12.0))

tone_table = []

for loop in 0...4 do
  octave = build_octave(key_c3 / (2.0 ** loop))
  for i in 0...12 do
    tone_table[36 - 12*loop + i] = octave[i]
  end
end

for loop in 1...8 do
  octave = build_octave(key_c3 * (2.0 ** loop))
  for i in 0...12 do
    tone_table[36 + 12*loop + i] = octave[i]
  end
end


# --- output
printf("// base clock = %d\n", BASECLOCK)
printf("// first divider = %d\n", DIVIDE1)
print("// 16bit PWM counter size\n")

name = ['C ','C#','D ','D#','E ','F ','F#','G ','G#','A ','A#','B ']
print("const WORD ToneTable[] = {\n")
for i in 0...128 do
  counter = BASECLOCK / DIVIDE1 / tone_table[i].to_i
  printf("  %d, // O%d %s - %fHz\n", counter.to_i,(i/12),name[i%12],tone_table[i])
end
print("};\n\n")
